#include <xc.h>
#include <string.h>

#define wait       for(w1=0;w1<50;w1++)
#define LED1 RC1
#define LED0 RC0


unsigned char buff[5];
unsigned long y, w1, a; 

void init (void); 
void SendDataBuffer1(const char *buffer, char size);
void ultoaa(unsigned long val);

void main(void) 
{ 
 init(); LED0=0;LED1=1;
 while (1) // bucla infinita
	 { 
     
		for(y=0; y<100000; y++); 
		LED0 = !LED0;   LED1 = !LED1;        
        SendDataBuffer1("\r\nTest connection = ", strlen("\r\nTest connection = "));
        ultoaa(a++);
        SendDataBuffer1(buff, strlen(buff));         
	 } 
} 
void init (void) 
{ 
 OSCCON=0x7B;       // REGLEAZA OSCILATORUL PE 16 MHz (PLL dezactivat)
 TRISA = 0x7F;
 TRISB = 0x0F;
 ANSELB = 0x00;
 
 // NU MODIFICATI AICI !!! 
 TRISC   = 0xB0;    // RX & TX communication
 SPBRG = 8;         // 16MHz 115200bps
 RCSTA = 0x90;
 TXSTA = 0x20;
 SYNC=0; BRGH=1; BRG16=0; 
 PIE1bits.RCIE = 1; //intrerupere de la portul serial
 PEIE = 1;          // intreruperea T1 face parte din "extra intreruperi"
 GIE = 1;           // activez Global intreruperile
// NU MODIFICATI AICI !!!  
} 
void __interrupt () my_isr_routine (void)  
{

    
    
    
// NU MODIFICATI AICI !!!    
    if(RCIF)   // for boot connection
    {        
        RCIF = 0;       
        asm("RESET");        
    }
// NU MODIFICATI AICI !!!          
}

void SendDataBuffer1(const char *buffer, char size)
{
    while(size)
    {
        wait;
        TXREG = (*buffer);
        buffer++;
        size--;
    }
}

void ultoaa(unsigned long val)
{
	unsigned char *p;
	unsigned char e;

	for(e=0; e<4; e++)
		{
			buff[e] = '0';
		}

	p = buff+sizeof(buff);
 	do
		{
			*--p = '0' + val%10;
			val/=10;
		}
	while(val);
}